$(document).ready(function() {
	var token = getUrlParam("token");
	var name = getUrlParam("name");
	var username = getUrlParam("username");
	if(token) {
		setCookie("token", decodeURIComponent(token));
	}
	if(name) {
		setCookie("name", decodeURIComponent(name));
	}
	if(username) {
		setCookie("username", decodeURIComponent(username));
	}
	$('.btn-toggle-fullwidth').on('click', function() {
		if(!$('body').hasClass('layout-fullwidth')) {
			$('body').addClass('layout-fullwidth');
		} else {
			$('body').removeClass('layout-fullwidth');
			$('body').removeClass('layout-default'); // also remove default behaviour if set
		}
		$(this).find('.lnr').toggleClass('lnr-arrow-left-circle lnr-arrow-right-circle');
		if($(window).innerWidth() < 1025) {
			if(!$('body').hasClass('offcanvas-active')) {
				$('body').addClass('offcanvas-active');
			} else {
				$('body').removeClass('offcanvas-active');
			}
		}
	});
	$('.sidebar a[data-toggle="collapse"]').on('click', function() {
		if($(this).hasClass('collapsed')) {
			$(this).addClass('active');
		} else {
			$(this).removeClass('active');
		}
	});
	$("#logout").on('click', function() {
		$.ajax({
			type: "POST",
			url: "/login/logout",
			data: null,
			dataType: "json",
			success: function(data) {
				if(data.success) {
					$.cookie('token', null, {
						expires: -1,
						path: "/"
					});
					$.cookie('token', null, {
						expires: -1,
						path: "/",
						domain: 'ah12301.com'
					});
					$.clearAllCookie();
					window.location.href = "/";
				}
			},
			error: function(XMLHttpRequest, textStatus, errorThrown) {
				alert("操作失败！");
			}
		});
	});
	$(".nav-top > li > a").on('click', function() {
		$(".nav-top > li > a").removeClass("active").addClass("collapsed");
		$(".nav-top > li > a").attr("aria-expanded", "false");
		$(".nav-top > li > div").removeClass('in');
		$(".nav-top > li > div").attr("aria-expanded", "false");
		$(".nav-child > li > a").removeClass("childActive");
		var clas = $(this).attr("class");
		$(this).addClass("active");
	});
	$(".nav-child > li > a").on('click', function() {
		$(".nav-child > li > a").removeClass("childActive");
		$(this).addClass("childActive");
	});
	var lia = $(".nav-top").find("li a").get(0);
	$(lia).trigger("click");
	//放大
	var quanping_status = false;
	$(".quanping").on('click', function() {
		quanping($(this));
		if(!quanping_status) {
			$(this).children("span").removeClass("iconquanping1");
			$(this).children("span").addClass("icontuichuquanping");
			quanping_status = true;
		} else {
			$(this).children("span").removeClass("icontuichuquanping");
			$(this).children("span").addClass("iconquanping1");
			quanping_status = false;
		}
	});
	//
	$("html,body,#wrapper,iframe,iframe>html>body").on('click', function() {
		var rm = document.getElementById("rightMenu");
		rm.style.display = "none";
	});
});
var setCookie = function(key, value) {
	var date = new Date();
	date.setTime(date.getTime() + 1 * 24 * 60 * 60 * 1000); //过期时间为一天
	$.cookie(key, value, {
		expires: date,
		path: '/'
	});
}

function getUrlParam(name) {
	var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
	var r = window.location.search.substr(1).match(reg);
	if(r != null) {
		return decodeURI(r[2])
	} else {
		return null
	}
}

function addTab(id, name, url) {
	var a = $("#tab_seed_" + id);
	if(a.length > 0) {
		closeTab(id, false);
	}
	var item = {
		'id': id,
		'name': name,
		'url': url,
		'closable': true
	};
	closableTab.addTab(item);
}

function closeTab(id, nextRefresh) {
	var a = $("#tab_seed_" + id).find('a')[0];
	var i = $(a).find('i')[0];
	closableTab.closeTab($(i));
	if(nextRefresh) {
		var p = $(".tab-pane.active");
		var iframe = $(p).find("iframe");
		document.getElementById($(iframe).attr("id")).contentWindow.location.reload(true);
	}
}

function refreshTab() {
	var p = $(".tab-pane.active");
	var iframe = $(p).find("iframe");
	document.getElementById($(iframe).attr("id")).contentWindow.location.reload(true);
}

function getUrl() {
	var p = $(".tab-pane.active");
	var iframe = $(p).find("iframe");
	return $(iframe).attr("src");
}

function loadMenu(obj) {
	var url = $(obj).attr("url");
	var a = $(obj).parent().parent().parent().siblings()[0];
	$(a).addClass('active');
	if(url != null && url != "" && url != undefined) {
		$("#content-main").load(url, function(responseTxt, statusTxt, xhr) {
			if(statusTxt == "error") {
				$("#content-main").html(responseTxt);
			}
		});
	}
}

function saveModify() {
	var oldPassworld = $("#oldPassworld").val();
	var newPassworld = $("#newPassworld").val();
	var newPassworldCo = $("#newPassworldCo").val();
	if(oldPassworld == null || oldPassworld == "" || trim(oldPassworld) == "") {
		alert("请输入原密码！");
		$("#oldPassworld").focus();
		return false;
	}
	if(newPassworld == null || newPassworld == "" || trim(newPassworld) == "") {
		alert("请输入新密码！");
		$("#newPassworld").focus();
		return false;
	}
	if(newPassworldCo == null || newPassworldCo == "" || trim(newPassworldCo) == "") {
		alert("请输入新密码确认！");
		$("#newPassworldCo").focus();
		return false;
	}
	if(newPassworldCo != newPassworld) {
		alert("新密码不一致！");
		$("#newPassworldCo").focus();
		return false;
	}
	$.ajax({
		type: "POST",
		url: "/private/modifyPassworld",
		data: {
			oldPassworld: oldPassworld,
			newPassworld: newPassworld
		},
		async: false,
		dataType: "json",
		success: function(data) {
			alert(data.message);
			if(data.success) {
				$('#myModalPassword').modal('hide');
				$("#logout").click();
			}
		},
		error: function(XMLHttpRequest, textStatus, errorThrown) {
			alert("操作失败！");
		}
	});
}
trim = function(str) {
	return str.replace(/(^\s*)|(\s*$)/g, "");
}

function $alert(message) {
	$("#modal-body").html(message);
	$('#myAlert').modal('show');

}

function topModalShow(title, html) {
	$("#topModalShowTitle").text(title);
	$("#topModalShowHtml").html(html);
	$('#topModalShow').modal('show');
}

function topModalHide(title, html) {
	$('#topModal').modal('hide');
}

function quanping() {
	var docElm = document.documentElement;
	if(docElm.requestFullscreen) {
		docElm.requestFullscreen();
	} else if(docElm.msRequestFullscreen) {
		docElm.msRequestFullscreen();
	} else if(docElm.mozRequestFullScreen) {
		docElm.mozRequestFullScreen();
	} else if(docElm.webkitRequestFullScreen) {
		docElm.webkitRequestFullScreen();
	}
	if(document.exitFullscreen) {
		document.exitFullscreen();
	} else if(document.msExitFullscreen) {
		document.msExitFullscreen();
	} else if(document.mozCancelFullScreen) {
		document.mozCancelFullScreen();
	} else if(document.webkitCancelFullScreen) {
		document.webkitCancelFullScreen();
	}
}

//
var tabId = null;
var rightMenu = function(obj) {
		event.preventDefault();
		var rm = document.getElementById("rightMenu");
		var e = event;
		//e=e || window.event;
		var mx = e.clientX + 5;
		var my = e.clientY + 5;
		//菜单宽度
		var rmWidth = parseInt(rm.style.width);
		//网页的宽度(高度用同样的方法解决)
		var pageWidth = document.documentElement.clientWidth;
		if((mx + rmWidth) < pageWidth) {
			rm.style.left = mx + "px";
			rm.style.top = my + "px";
		} else {
			rm.style.right = mx + "px";
			rm.style.top = my + "px";
		}
		//3.显示右键菜单
		rm.style.display = "block";
		//阻止默认的右键菜单显示
		tabId = $(obj).attr("value");
	}
	//
var shuaxin = function() {
	refreshTab();
}
var guanbi = function() {
	closeTab(tabId, false);
}