$(function() {

	addListener();
	
    $('.updateAttachFile').click(function(){
    	var formdata=new FormData(document.querySelector("#attachFile"));
    	var files = formdata.getAll("files");
    	var file_list=[];
    	for (var i = 0; i < files.length; i++) {
			if(files[i].name=="")continue;
			file_list.push(files[i].name);
		}
    	if(file_list.length<=0)return false;
    	
		$.ajax({
	        type: "POST",
	        url: "/private/info/uploadFiles",
	        data: formdata,
	        async:true,
	        dataType: "json",
            processData: false,
            contentType: false,
	        success: function(data){
	        	if (data.data) {
	        		var result=data.data;
	        		for(var i=0;i<result.length;i++){
	        			var fileNP = result[i].split("-");
	        			var html='<span data-path='+fileNP[1]+'>'+fileNP[0]+'</span>';
						html+='<a href="javascript:void(0);" class="glyphicon glyphicon-remove deleteImg" aria-hidden="true"></a>';
						$("#attach").append(html);
	        		}
	        		addListener();
				}else {
					alert("文件上传失败");
				}
	        },error: function(XMLHttpRequest, textStatus, errorThrown){
	        	alert("文件上传失败！");
	        }
	    });
    });	
    
    $('.updateServer').click(function(){
		var imgs = getImgs();
		if (imgs.length>=5) {
			alert("封面最多只能上传5张");
			return false;
		}
    	var formdata=new FormData(document.querySelector("#uploadCover"));
    	var fileName = formdata.get("upload").name;
    	if (""==fileName) return false;
    	if (!isImage(fileName,formdata.get("upload").size)) return false;
    	
		$.ajax({
	        type: "POST",
	        url: "/private/info/uploadFile",
	        data: formdata,
	        async:true,
	        dataType: "json",
            processData: false,
            contentType: false,
	        success: function(data){
	        	if (data!=null&&data.url!="") {
					var html='<div><img src="'+data.url+'" alt="无法显示图片" class="img-rounded">';
					html+='<a href="javascript:void(0);" class="glyphicon glyphicon-remove deleteImg" aria-hidden="true"></a></div>';
					$("#coverImage").append(html);
					
					addListener();
				}else {
					alert("文件上传失败");
				}
	        },error: function(XMLHttpRequest, textStatus, errorThrown){
	        	alert("文件上传失败！");
	        }
	    });	
    });
    
});

function addListener() {
	$(".deleteImg").click(function() {
		$(this).prev().addClass("hideImg");
		$(this).addClass("hideImg");
	});	
}

function getFormdata(formdata) {
	var jsonData ={};
	formdata.forEach(function(value, key){
		jsonData[key]=value;
	});
	return jsonData ;
}

function isImage(fileName,fileSize) {
	var lastIndex=fileName.lastIndexOf('.');
	if(lastIndex==-1){
		alert("文本件类型不正确,无法上传");
		return false;
	}
	var fileSuffix=fileName.substr(fileName.lastIndexOf('.'));
	if(!/.(gif|jpg|jpeg|png)$/.test(fileSuffix)){
		alert("文本件类型不正确，请上传图片格式文件");
		return false;			
	}
	if (fileSize/1024>1024) {
		alert("文件都不能大于1M");
		return false;	
	}
	return true;
}

function getFiles() {
	var imgs=[];
	var images = $("#attach span");
	for (var i=0;i<images.length;i++) {
		if (!$(images[i]).hasClass("hideImg")) {
			var filename= $(images[i]).text();
			var filepath=$(images[i]).attr("data-path");
			imgs.push(filename+"-"+filepath);
		}
	}
	return  imgs;
}

function getImgs() {
	var imgs=[];
	var images = $("#coverImage img");
	for (var i=0;i<images.length;i++) {
		if (!$(images[i]).hasClass("hideImg")) {
			
			var urlImg = $(images[i]).attr("src");
			var index = urlImg.lastIndexOf("/")+1
			imgs.push(urlImg.substr(index));
		}
	}
	return imgs;
}
function save(editor,formdata,url,closetab) {
	
	var title = $("#title").val();
	if(title==""||title.replace(/(^\s*)|(\s*$)/g,"")==""){
		alert("资讯标题不可为空");
		return false;
	}
	
	var type=$("#select_type").val();
	if(type==""||type.replace(/(^\s*)|(\s*$)/g,"")==""){
		alert("请选择资讯类型");
		return false;
	}
	
	var imgs = getImgs();
	if (imgs.length<1) {
		alert("请上传资讯封面");
		return false;
	}
	
	
	formdata.append("picture", imgs[0]);
	formdata.append("images", imgs);
	
	var editoText = editor.document.getBody().getText();
	var editorData = editor.getData();
	if((editoText==""||editoText.replace(/(^\s*)|(\s*$)/g,"")=="")&&editorData==""){
		alert("资讯内容不可为空");
		return false;
	}	
	formdata.append("content", editor.getData());
	var file_list = getFiles();
	if (file_list.length>0) {
		formdata.append("files", file_list);
	}
	
	var data = getFormdata(formdata);
	$.ajax({
        type: "POST",
        url: url,
        data: data,
        async:false,
        dataType: "json",
        success: function(data){
        	if(data.success){
        		parent.closeTab(closetab);
        	}else {
        		alert("操作失败");
			}	
        },error: function(XMLHttpRequest, textStatus, errorThrown){
        	alert("操作失败！");
        }
    });			
}
