<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<%
	pageContext.setAttribute("APP_PATH", request.getContextPath());
%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<c:choose>
	<c:when test="${param.id == 0}">
		<c:set var="url" value="/saveVideo"></c:set>
		<c:set var="text" value="新增"></c:set>
	</c:when>
	<c:otherwise>
		<c:set var="url" value="/updateVideo"></c:set>
		<c:set var="text" value="修改"></c:set>
	</c:otherwise>
</c:choose>
<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <title>${text }视频</title>
  <meta name="renderer" content="webkit">
  <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
  <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">
<link rel="stylesheet" href="${APP_PATH }/static/layui/css/layui.css"  media="all">
<link rel="stylesheet" href="${APP_PATH }/static/mycss/style.css">
</head>
<style>
	.contPadding{
		padding-top: 20px;
		width: 350px;
	}
	
</style>
<body class="contPadding">                   
	<form class="layui-form" id="form" action="/douyin/save" commandName="obj" lay-filter="formFilter">
	 <div class="layui-form-item" style="display: none;">
    	<label class="layui-form-label">id</label>
    	<div class="layui-input-block">
      		<input type="text" name="id" lay-verify="id" id="adminId" class="layui-input" value='${param.id }'>
    	</div>
     </div>
	 <div class="layui-form-item">
    	<label class="layui-form-label">视频名称</label>
    	<div class="layui-input-block">
      		<input type="text" name="name" id="name" lay-verify="name" autocomplete="off" placeholder="请输入视频名称" class="layui-input" value='${douyin.name }'>
    	</div>
     </div>
	  <div class="layui-form-item">
	    <label class="layui-form-label">是否热门</label>
	    <div class="layui-input-block">
	      <input type="checkbox"  name="videoIsHots" id="videoIsHots"  <c:if test="${'1' == douyin.isHot}">checked="checked"</c:if>  lay-skin="switch" lay-text="已选热门|不是热门" lay-filter="videoIsHot">
	    </div>
	  </div>
	  <div class="layui-form-item">
	     <label class="layui-form-label">视频地址</label>
		 <div class="layui-input-block">
		  	<input type="text" name="videoPath" id="videoPath" lay-verify="videoPath" autocomplete="off" placeholder="请输入视频地址" class="layui-input" value='${douyin.videoPath }'>
		 </div>  
	  </div>
	  <input type="hidden" name="isHot" id="isHot"  value="${douyin.isHot}">
	  <button class="layui-btn" lay-submit lay-filter="submmitFilter" style="display: none;" id="sunmitbtn"></button>
	</form>
	     
	<!-- JS -->
	<script src="${APP_PATH }/static/layui/layui.js"></script>
	<script src="${APP_PATH }/static/jquery/1.9.1/jquery.min.js"></script>
	<script>
	
	
	var parentIndex;
	layui.use(['form'], function(){
		  var form = layui.form
		  ,layer = layui.layer
		  //表单验证
		  form.verify({
			  name: function(value, item){ //value：表单的值、item：表单的DOM对象
				value = $.trim(value);
			  	if(value.length == 0){
			  		return '视频名不能为空';
			  	}
			  	if(value.length > 355){
			  		return '视频名长度不能大于355个字'
			  	}
			  },
			  videoPath: function(value, item){ //value：表单的值、item：表单的DOM对象
					value = $.trim(value);
				  	if(value.length == 0){
				  		return '链接地址不能为空';
				  	}
				  }
		  });
		  //监听提交
		  form.on('submit(submmitFilter)', function(data){
			  $.ajax({
					url: "/douyin/save",
					type: 'POST',
					data: $("#form").serialize(),
					async:false,
					success: function(result){
						var code = result.code;
		    			if(code == 0){
	    					layer.msg('操作成功', {
	    		    			  icon: 6
	    		    			  ,time: 1500
	    		    		});
		    				setTimeout(function(){
		    					parent.conditionReset();
		    					parent.layer.close(parentIndex);
		    				}, 1500);
		    			}else{
		    				layer.msg(result.msg, {
	    		    			  icon: 5
	    		    			  ,time: 1500
	    		    		});
		    			}
		    		},
		    		error: function() {
		    			layer.msg('提交失败', {
			    			  icon: 5
			    			  ,time: 1500
			    		});
		    		}
		    	});
			    return false; 
		  });
		  
	});
	//模拟按钮提交 
	function submitForm(index){
		parentIndex = index;
		$("#sunmitbtn").click();
	}
	
	
	
	
	
	
	
	
	
	</script>

</body>
</html>