$(document).ready(function() {
	var token = getUrlParam("token");
	var name = getUrlParam("name");
	var username = getUrlParam("username");
	if(token) {
		setCookie("token", decodeURIComponent(token));
	}
	if(name) {
		setCookie("name", decodeURIComponent(name));
	}
	if(username) {
		setCookie("username", decodeURIComponent(username));
	}
	$('.btn-toggle-fullwidth').on('click', function() {
		if(!$('body').hasClass('layout-fullwidth')) {
			$('body').addClass('layout-fullwidth');
		} else {
			$('body').removeClass('layout-fullwidth');
			$('body').removeClass('layout-default'); // also remove default behaviour if set
		}
		$(this).find('.lnr').toggleClass('lnr-arrow-left-circle lnr-arrow-right-circle');
		if($(window).innerWidth() < 1025) {
			if(!$('body').hasClass('offcanvas-active')) {
				$('body').addClass('offcanvas-active');
			} else {
				$('body').removeClass('offcanvas-active');
			}
		}
	});
	$('.sidebar a[data-toggle="collapse"]').on('click', function() {
		if($(this).hasClass('collapsed')) {
			$(this).addClass('active');
		} else {
			$(this).removeClass('active');
		}
	});
	$("#logout").on('click', function() {
		$.ajax({
			type: "POST",
			url: "/login/logout",
			data: null,
			dataType: "json",
			success: function(data) {
				if(data.success) {
					$.cookie('token', null, {
						expires: -1,
						path: "/"
					});
					$.cookie('token', null, {
						expires: -1,
						path: "/",
						domain: 'ah12301.com'
					});
					$.clearAllCookie();
					window.location.href = "/";
				}
			},
			error: function(XMLHttpRequest, textStatus, errorThrown) {
				alert("操作失败！");
			}
		});
	});
});
var setCookie = function(key, value) {
	var date = new Date();
	date.setTime(date.getTime() + 1 * 24 * 60 * 60 * 1000); //过期时间为一天
	$.cookie(key, value, {
		expires: date,
		path: '/'
	});
}

function getUrlParam(name) {
	var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
	var r = window.location.search.substr(1).match(reg);
	if(r != null) {
		return decodeURI(r[2])
	} else {
		return null
	}
}
function saveModify() {
	var oldPassworld = $("#oldPassworld").val();
	var newPassworld = $("#newPassworld").val();
	var newPassworldCo = $("#newPassworldCo").val();
	if(oldPassworld == null || oldPassworld == "" || trim(oldPassworld) == "") {
		alert("请输入原密码！");
		$("#oldPassworld").focus();
		return false;
	}
	if(newPassworld == null || newPassworld == "" || trim(newPassworld) == "") {
		alert("请输入新密码！");
		$("#newPassworld").focus();
		return false;
	}
	if(newPassworldCo == null || newPassworldCo == "" || trim(newPassworldCo) == "") {
		alert("请输入新密码确认！");
		$("#newPassworldCo").focus();
		return false;
	}
	if(newPassworldCo != newPassworld) {
		alert("新密码不一致！");
		$("#newPassworldCo").focus();
		return false;
	}
	$.ajax({
		type: "POST",
		url: "/private/modifyPassworld",
		data: {
			oldPassworld: oldPassworld,
			newPassworld: newPassworld
		},
		async: false,
		dataType: "json",
		success: function(data) {
			alert(data.message);
			if(data.success) {
				$('#myModalPassword').modal('hide');
				$("#logout").click();
			}
		},
		error: function(XMLHttpRequest, textStatus, errorThrown) {
			alert("操作失败！");
		}
	});
}
trim = function(str) {
	return str.replace(/(^\s*)|(\s*$)/g, "");
}