$(function() {
	addListener();	
	addListener_1();
})

function editor_upload(editorId,pathUrl) {
	/**
	 * wangEditor扩展,增加全屏 查看源码功能
	 * 传入均为 editor实例,非css选择器
	 * 依赖jquery 如果是layui之类的需要在layui.use方法中使用
	 * 全屏功能需要引入 wangEditor-fullscreen.css
	 * @author mrzhou@miw.cn
	 * @date 2018.8.30 am 10:00
	 *       2018.9.18 pm 16:00 增加同页多编辑器支持
	 * 使用方法:
	 * E.fullscreen.init(editor);
	 * E.viewSource.init(editor);
	 */

	window.wangEditor.fullscreen = {
	    init: function(editor) {
	    	id = editor.id;
	    	if(!this.pluginsEditors){
	    		this.pluginsEditors = {}
	    	}
	    	if(this.pluginsEditors[id]){
	    		editor = this.pluginsEditors[id];
	    	} else {
	    		this.pluginsEditors[id]=editor;
	    	}
	    	editor.isFullScreen = false;
	    	toolbar = editor.$toolbarElem[0];
	        $(toolbar).append('<div class="w-e-menu btn_fullscreen" onclick="window.wangEditor.fullscreen.run(\''+id+'\')">全屏</div>');
	    },
	    run: function(id) {
	    	editor = this.pluginsEditors[id];
	    	editor.isFullScreen = editor.isFullScreen;
	    	container = $(editor.toolbarSelector);
	        container.toggleClass('fullscreen-editor');
	        container.find('.btn_fullscreen').text(this.isFullScreen ? '退出全屏': '全屏');
	    }
	};
	window.wangEditor.viewSource = {
	    init: function(editor) {
	    	id = editor.id;
	    	if(!this.pluginsEditors){
	    		this.pluginsEditors = {}
	    	}
	    	if(this.pluginsEditors[id]){
	    		editor = this.pluginsEditors[id];
	    	} else {
	    		this.pluginsEditors[id]=editor;
	    	}
	    	editor.isHTML = false;
	        toolbar = editor.$toolbarElem[0];
	        $(toolbar).append("<div class='w-e-menu btn_viewSource' title='查看源码' onclick='window.wangEditor.viewSource.run(\""+id+"\")'>\n            <i class='w-e-icon-viewSource'></i>\n        </div>");
	    },
	    run: function(id) {
	    	editor = this.pluginsEditors[id];
	        editor.isHTML = !editor.isHTML;
	        _source = editor.txt.html();
	        toolbar = editor.$toolbarElem[0];
	        if (editor.isHTML) {
	            _source = _source.replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/ /g, "&nbsp;");
	            $(toolbar).find('.w-e-menu').css({ "display": "none" });
	            $(toolbar).find('.btn_viewSource').css({ "display": "" });
	        } else {
	            _source = editor.txt.text().replace(/&lt;/ig, "<").replace(/&gt;/ig, ">").replace(/&nbsp;/ig, " ");
	            $(toolbar).find('.w-e-menu').css({ "display": "" });
	            editor.change && editor.change();
	        }
	        editor.txt.html(_source);
	    }
	};
	
	var E = window.wangEditor;
	var editor = new E(editorId);
	editor.customConfig.uploadImgServer = "https://res.ah12301.com/api/ordinary/upload";
	editor.customConfig.uploadImgParams = {
			path: pathUrl
	};
	editor.customConfig.uploadFileName = 'file';
    // 关闭粘贴样式的过滤
    editor.customConfig.pasteFilterStyle = false
    // 忽略粘贴内容中的图片
    editor.customConfig.pasteIgnoreImg = true
    // 自定义处理粘贴的文本内容
    editor.customConfig.pasteTextHandle = function (content) {

        // content 即粘贴过来的内容（html 或 纯文本），可进行自定义处理然后返回
        if (content == '' && !content) return ''
        var str = content
        str = str.replace(/<xml>[\s\S]*?<\/xml>/ig, '')
        str = str.replace(/<style>[\s\S]*?<\/style>/ig, '')
        str = str.replace(/<([a-zA-Z1-6]+)(\s*[^>]*)?>/g, "<$1>")
        str = str.replace(/<!(\-)?[\w\W\r\n]*?(\-)?>/g, '')
        /*str = str.replace(/(\\n|\\r|style=((")|(\'))?[a-zA-Z\-\:"]+((")|(\'))?)/g,'')
        str = str.replace(/(\\n|\\r|style=((")|(\'))?[a-zA-Z\-\:"]+((")|(\'))?)/g,'')
        str = str.replace(/(\\n|\\r|class=((")|(\'))?[a-zA-Z\-\:"]+((")|(\'))?)/g,'')
        str = str.replace(/(\\n|\\r|lang=((")|(\'))?[a-zA-Z\-\:]+((")|(\'))?)/g,'')*/
        return str
    }

	editor.customConfig.uploadImgMaxLength = 1;
	editor.customConfig.uploadImgHooks = {
	    // 上传超时
	    timeout: function (xhr, editor) {
	        layer.msg('上传超时！')
	    },
	    // 如果服务器端返回的不是 {errno:0, data: [...]} 这种格式，可使用该配置
	    customInsert: function (insertImg, result, editor) {
	        if (result.message == 'success') {
	    		var getImageUrl = imgServer + "/api/image/"; //获取图片的接口
	    		var url = getImageUrl + pathUrl + "/" + result.data;
	    		if(pathUrl=="strategy"){
	    			url+="?width=600";
	    		}
	            insertImg(url);
	        } else {
	            layer.msg(result.message);
	        }
	    }
	};
	editor.customConfig.customAlert = function (info) {
	    layer.msg(info);
	};
	if(pathUrl=="line_detail"){
		// 自定义菜单配置
		editor.customConfig.menus = [
			'head',  // 标题
			'bold',  // 粗体
			'fontSize',  // 字号
			'fontName',  // 字体
			'italic',  // 斜体
			'underline',  // 下划线
			'strikeThrough',  // 删除线
			'foreColor',  // 文字颜色
			'backColor',  // 背景颜色
			'link',  // 插入链接
			'list',  // 列表
			'justify',  // 对齐方式
			'quote',  // 引用
			'emoticon',  // 表情
			'image',  // 插入图片
			'table',  // 表格
			'video',  // 插入视频
			'undo',  // 撤销
			'redo',  // 重复
			'formatExt',  // 清楚格式
			//'formatExt2',  // 清楚格式
			'emoticonExt'  // 表情
			];
	}else {
		// 自定义菜单配置
		editor.customConfig.menus = [
			'head',  // 标题
			'bold',  // 粗体
			'fontSize',  // 字号
			'fontName',  // 字体
			'italic',  // 斜体
			'underline',  // 下划线
			'strikeThrough',  // 删除线
			'foreColor',  // 文字颜色
			'backColor',  // 背景颜色
			'link',  // 插入链接
			'list',  // 列表
			'justify',  // 对齐方式
			'quote',  // 引用
			'emoticon',  // 表情
			'image',  // 插入图片
			'table',  // 表格
			'video',  // 插入视频
			'undo',  // 撤销
			'redo',  // 重复
			'formatExt'  // 清楚格式
			];
		
	}
	editor.create();
	E.viewSource.init(editor);
	return editor;
}
function upload(pathUrl) {
    $("#timg_src_list").sortable();
    $("#timg_src_list").disableSelection();
	layui.use('upload', function() {
		//var pathUrl = "scenic"; //图片的目录
		var getImageUrl = imgServer + "/api/image/"; //获取图片的接口
		var upload = layui.upload;
		//执行实例
		var uploadInst = upload.render({
			elem: '#img', //绑定元素
			url: 'https://res.ah12301.com/api/ordinary/upload', //上传接口
			field: "file",
			exts: 'jpg|png|gif',
			data: {
				path: pathUrl
			},
			done: function(res) {
				//上传完毕回调
				var img = getImageUrl + pathUrl + "/" + res.data;
				var html = '<li><div class="file-footer-buttons"><span class="glyphicon glyphicon-remove deleteImg_1" title="删除文件"></span></div><img src="'+img+'"></li>';	
				$("#img_one").html(html)
				$("#imgAttr").val(img);
				addListener_1();
			},
			error: function() {
				//请求异常回调
				alert("图片上传失败");
			}
		});	
		//video 封面
		var uploadInst = upload.render({
			elem: '#videoImg', //绑定元素
			url: 'https://res.ah12301.com/api/ordinary/upload', //上传接口
			field: "file",
			exts: 'jpg|png|gif',
			data: {
				path: pathUrl
			},
			done: function(res) {
				//上传完毕回调
				var img = getImageUrl + pathUrl + "/" + res.data;
				var html = '<li><div class="file-footer-buttons"><span class="glyphicon glyphicon-remove deleteImg_1" title="删除文件"></span></div><img src="'+img+'"></li>';	
				$("#img_video").html(html)
				addListener_1();
			},
			error: function() {
				//请求异常回调
				alert("图片上传失败");
			}
		});
		//详情头部图片
		var uploadInst = upload.render({
			elem: '#timg', //绑定元素
			url: 'https://res.ah12301.com/api/ordinary/upload', //上传接口
			field: "file",
			exts: 'jpg|png|gif',
			data: {
				path: pathUrl
			},
			done: function(res) {
				//上传完毕回调
				var img = getImageUrl + pathUrl + "/" + res.data;
				var html = '<li><div class="file-footer-buttons"><span class="glyphicon glyphicon-remove deleteImg_1" title="删除文件"></span></div><img src="'+img+'"></li>';	
				$('#timg_src_list').append(html);
				addListener_1();	
			},
			error: function() {
				//请求异常回调
				alert("图片上传失败");
			}
		});	
		var srcFileName;
		//附件上传
		var uploadInst = upload.render({
			elem: '#files', //绑定元素
			url: '/private/info/uploadFiles', //上传接口
			field: "file",
			accept: 'file', //普通文件
			data: {
				path: pathUrl
			},
			before: function(obj){
			      //预读本地文件示例，不支持ie8
			      obj.preview(function(index, file, result){
			    	  srcFileName=file.name;
			      });
			},
			done: function(res) {
				//上传完毕回调
				var img = res.data;
				 $('#files_src_list').append('<div><span data-path="'+img+'">'+srcFileName+'</span><a href="javascript:void(0);" class="glyphicon glyphicon-remove deleteImg" aria-hidden="true"></a></div>');
				addListener();	
			},
			error: function() {
				//请求异常回调
				alert("附件上传失败");
			}
		});	
		//视频上传
		var srcFileName;
		var uploadInst = upload.render({
			elem: '#video_btn', //绑定元素
			url: 'https://res.ah12301.com/api/video/upload', //上传接口
			field: "file",
			accept: 'file',//普通文件
			before: function(obj){
			      //预读本地文件示例，不支持ie8
			      obj.preview(function(index, file, result){
			    	  srcFileName=file.name;
			      });
			},
			done: function(res) {
				//上传完毕回调
				var video = "https://res.ah12301.com" + res.data;
				$('#files_src_list').html('<div style="display: flex;"></a><video id="video" src="'+video+'" controls="controls" style="margin-top: 5px;display: block;width:400px;height:100%;object-fit:cover;"></video><a href="javascript:void(0);" class="glyphicon glyphicon-remove deleteImg" aria-hidden="true" style="float: right;padding-top: 5px;"></div>');
				addListener();	
			},
			error: function() {
				//请求异常回调
				alert("视频上传失败");
			}
		});	
	});	
}

function upload_1(pathUrl,imageId,imageViewId) {
	$(imageViewId).sortable();
	$(imageViewId).disableSelection();
	layui.use('upload', function() {
		//var pathUrl = "scenic"; //图片的目录
		var getImageUrl = imgServer + "/api/image/"; //获取图片的接口
		var upload = layui.upload;
		//详情头部图片
		var uploadInst = upload.render({
			elem: imageId, //绑定元素
			url: 'https://res.ah12301.com/api/ordinary/upload', //上传接口
			field: "file",
			exts: 'jpg|png|gif',
			data: {
				path: pathUrl
			},
			done: function(res) {
				//上传完毕回调
				var img = getImageUrl + pathUrl + "/" + res.data;
				var html = '<li><div class="file-footer-buttons"><span class="glyphicon glyphicon-remove deleteImg_1" title="删除文件"></span></div><img src="'+img+'"><div style="display:flex;"><span style="color: red;	margin-right: 4px;vertical-align: middle;padding-top: 20px;">*</span><input lay-verify="required" value="" placeholder="请输入图片说明" class="layui-input" style="margin-top: 10px;"/></div></li>';	
				$(imageViewId).append(html);
				addListener_1();	
			},
			error: function() {
				//请求异常回调
				alert("图片上传失败");
			}
		});	
	});	
}

function addListener() {
	$(".deleteImg").click(function() {
		var contenttip;
		if ($(this).closest("div").find("video").length > 0) {
			 contenttip='视频';
		}else if ($(this).closest("div").find("img").length > 0) {
			 contenttip='图片';
		}else {
			contenttip='文件';
		}
		var thisd= $(this);
	    layer.open({
	        type: 1,
	        title: '提示', //false不显示标题栏
	        closeBtn: false,//false,
	        area: '300px;',//'300px;',
	        btnAlign: 'c',
	        id: 'tip_delete',//'tip_delete' //设定一个id，防止重复弹出
	        moveType: 0, //拖拽模式，0或者1
	        content: '<div style="padding: 20px 0;text-align: center;">确定删除该'+contenttip+'？</div>',//'<div style="padding: 20px 0;text-align: center;">确定删除该资讯？</div>'
	        btn: ["删除","关闭"], //删除 关闭
	        btn2: function(){
	      	  layer.closeAll();
	        },
	        btn1: function(){
	    		thisd.prev().addClass("hideImg");
	    		thisd.attr("style","display: none;");
	    		thisd.closest("div").find("video").attr("style","display: none;");
	    	    layer.closeAll();
	       }
	    });
	});	
}

function addListener_1() {
	$(".deleteImg_1").click(function() {
		var id = $(this).parent().parent('li');
	    layer.open({
	        type: 1,
	        title: '提示', //false不显示标题栏
	        closeBtn: false,//false,
	        area: '300px;',//'300px;',
	        btnAlign: 'c',
	        id: 'tip_delete',//'tip_delete' //设定一个id，防止重复弹出
	        moveType: 0, //拖拽模式，0或者1
	        content: '<div style="padding: 20px 0;text-align: center;">确定删除该图片？</div>',//'<div style="padding: 20px 0;text-align: center;">确定删除该资讯？</div>'
	        btn: ["删除","关闭"], //删除 关闭
	        btn2: function(){
	      	  layer.closeAll();
	        },
	        btn1: function(){
	    	    id.remove();
	    	    layer.closeAll();
	       }
	    });			
	});    

}

function getImgs() {
	var imgs=[];
	var images = $("#timg_src_list img");
	for (var i=0;i<images.length;i++) {
		if (!$(images[i]).parent().parent().hasClass("hideImg")) {
			var urlImg = $(images[i]).attr("src");
			imgs.push(urlImg+"-"+i);
		}
	}
	return imgs;
}
function getVideoImg() {
	var imgs=[];
	var images = $("#img_video img");
	for (var i=0;i<images.length;i++) {
		if (!$(images[i]).parent().parent().hasClass("hideImg")) {
			var urlImg = $(images[i]).attr("src");
			imgs.push(urlImg);
		}
	}
	return imgs;
}
function getVideo() {
	var imgs=[];
	var images = $("#files_src_list video");
	for (var i=0;i<images.length;i++) {
		if (!$(images[i]).hasClass("hideImg")) {
			var filepath=$(images[i]).attr("src");
			imgs.push(filepath);
		}
	}
	return  imgs;
}

function getImgsOne() {
	var imgs=[];
	var images = $("#img_one img");
	for (var i=0;i<images.length;i++) {
		if (!$(images[i]).parent().parent().hasClass("hideImg")) {
			var urlImg = $(images[i]).attr("src");
			imgs.push(urlImg);
		}
	}
	return imgs;
}
function getFiles() {
	var imgs=[];
	var images = $("#files_src_list span");
	for (var i=0;i<images.length;i++) {
		
		if (!$(images[i]).hasClass("hideImg")) {
			var filename= $(images[i]).text();
			var filepath=$(images[i]).attr("data-path");
			imgs.push(filename+"-"+filepath);
		}
	}
	return  imgs;
}

function getImgs_1(imgView){
	var imgs=[];
	var images = $(imgView);
	for (var i=0;i<images.length;i++) {
		if (!$(images[i]).parent().parent().hasClass("hideImg")) {
			var urlImg = $(images[i]).attr("src");
			var remark=$(images[i]).next().find("input").val();
			if(remark!="")imgs.push(urlImg+"-"+i+"-"+remark);
		}
	}
	return imgs;
}



