/*-----Utils---------*/
var Utils = {};
Utils.getXData = function(data) {
	var XData = [];
	data.map(function(e) {
		XData.push(e.name);
	})
	return XData;
};
Utils.getSeriesData = function(data) {
	var SeriesData = [];
	data.map(function(e) {
		SeriesData.push(e.value);
	})
	return SeriesData;
};
Utils.getMaxData = function(data) {
	var maxData = [];
	data.map(function(e) {
		maxData.push(e.max);
	})
	return maxData;
};
Utils.getMinData = function(data) {
	var minData = [];
	data.map(function(e) {
		minData.push(e.min);
	})
	return minData;
};
Utils.getPercentSeriesData = function(data) {
	var SeriesData = [];
	var all = 0;
	data.map(function(e) {
		all += parseInt(e.value);
	})
	data.map(function(e) {
		SeriesData.push(Math.floor(parseInt(e.value) / all * 10000) / 100);
	})
	return SeriesData;
};
Utils.getNowYear = function() {
	var today = new Date();
	return today.getFullYear();
};
Utils.getWeatherImg = function(type) {
	var imgUtl = 'images/w_duoyun.png';
	if(type.indexOf("多云") != -1) {
		imgUtl = "images/w_duoyun.png";
	} else if(type.indexOf("阴") != -1) {
		imgUtl = "images/w_yin.png";
	} else if(type.indexOf("晴") != -1) {
		imgUtl = "images/w_qing.png";
	} else if(type.indexOf("小雨") != -1) {
		imgUtl = "images/w_xiaoyu.png";
	} else if(type.indexOf("雨夹雪") != -1) {
		imgUtl = "images/w_yujiaxue.png";
	} else if(type.indexOf("阵雨") != -1) {
		imgUtl = "images/w_zhenyu.png";
	} else if(type.indexOf("雨") != -1) {
		imgUtl = "images/w_yu.png";
	} else if(type.indexOf("冰雹") != -1) {
		imgUtl = "images/w_bingbao.png";
	} else if(type.indexOf("大雪") != -1) {
		imgUtl = "images/w_daxue.png";
	} else if(type.indexOf("雪") != -1) {
		imgUtl = "images/w_xue.png";
	}
	return imgUtl;
};
/*-------获取相对当天几天的日期------*/
/**
 * 
 * @param {Object} start 
 * @param {Object} end
 * @param {Object} "week" or "day"
 */
function getNearDays(start, end, type) {
	var days = [];
	for(var i = start; i < end; i++) {
		days.push(getDay(i, type));
	}
	return days;
}

function getDay(day, type) {
	var today = new Date();
	var targetday_milliseconds = today.getTime() + 1000 * 60 * 60 * 24 * day;
	today.setTime(targetday_milliseconds); //注意，这行是关键代码  
	var tMonth = today.getMonth();
	var tDate = today.getDate();
	var tWeek = today.getDay();
	tMonth = doHandleMonth(tMonth + 1);
	tDate = doHandleMonth(tDate);
	if(type == "day") {
		return tMonth + "/" + tDate;
	} else if(type == "week") {
		return formatterWeek(tWeek);
	}
	return null;
}

function formatterWeek(week) {
	var str = "";
	if(week == 0) {
		str = "周日";
	} else if(week == 1) {
		str = "周一";
	} else if(week == 2) {
		str = "周二";
	} else if(week == 3) {
		str = "周三";
	} else if(week == 4) {
		str = "周四";
	} else if(week == 5) {
		str = "周五";
	} else if(week == 6) {
		str = "周六";
	}
	return str;
}

function doHandleMonth(month) {
	var m = month;
	if(month.toString().length == 1) {
		m = "0" + month;
	}
	return m;
}
/*-------获取相对当天几天的日期  end------*/

/*获取最近几小时*/
function getNearHours(start, end) {
	var hours = [];
	for(var i = start; i < end; i++) {
		var hour = getHour(i);
		if(hour < 10) {
			hour = "0" + hour;
		}
		hours.push(hour + "时");

	}
	return hours;
}
/*获取从N点到现在的时间段，最大不超过max*/
function getHoursToNow(N, max) {
	var date = new Date();
	var hours = [];
	var now = date.getHours();
	now = now > max ? max : now;
	for(var i = N; i < now; i++) {
		var hour = i;
		if(hour < 10) {
			hour = "0" + hour;
		}
		hours.push(hour + "时");

	}
	return hours;
}

function getHour(hour) {
	var now = new Date();
	var targetday_milliseconds = now.getTime() + 1000 * 60 * 60 * hour;
	now.setTime(targetday_milliseconds); //注意，这行是关键代码  
	var tHour = now.getHours();
	return tHour;
}
/*---------end------------*/
(function(w) {
	w.animateNumber = function(ele, number) {
		if(number == 0) {
			ele.text(number);
		} else {
			var start = 0;
			var current = 0;
			var intv = setInterval(function() {
				if(current < number) {
					current += number / 50;
					if(current >= number) {
						ele.text(number);
						clearInterval(intv);
					} else {
						ele.text(parseInt(current));
					}
				}
			}, 20);
		}
	};
})(window)